diff --git a/kx.c b/kx.c
index 02373c8..c804b91 100644
--- a/kx.c
+++ b/kx.c
@@ -770,7 +770,8 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
   t3=ex_(*v,1);
   if(t3>(K)DT_SIZE && t3->t==7 && t3->n==3){
     if(prnt && kV(prnt)[CACHE_TREE] && kV(prnt)[CACHE_WD]){
-      if(kK(prnt)[CACHE_TREE]->n && kK(prnt)[LOCALS]->n && !kK(t3)[LOCALS]->n) {
+      if(kK(prnt)[CACHE_TREE]->n && kK(prnt)[LOCALS]->n && !kK(t3)[LOCALS]->n && 
+         kK(kK(prnt)[CACHE_WD])[LOCALS]->n>1) {
         f2s=1;
         cd(kK(t3)[CACHE_TREE]); kK(t3)[CACHE_TREE]=kK(prnt)[CACHE_TREE]; ci(kK(t3)[CACHE_TREE]);
       }
diff --git a/tests.c b/tests.c
index b23d87f..fecc979 100644
--- a/tests.c
+++ b/tests.c
@@ -191,6 +191,7 @@ Z I tests02()
   TC(2 6 24, {b:3; g:{b}; a::{:[x<2; 1; _f[x-1]*x]}/:2 3 4; g[ ]}0; a) // embedded _f with list-arg
   TC( 5, {x + {[a] a+a} y}[1;2])        // Leon Baum test
   TC( 5, {[a;b] a + {x+x} b}[1;2])      // Leon Baum test-2
+  TC( 3, {[n]a:n;{x}a}3 )               // Variable scope problem
 
   //Error trap: {[a;b][c;d] a+b} -> parse error ; { {[a][b] }} -> parse error
   TC(.[*; (3;4); :], (0;12) )
